#!/usr/bin/python3
# -*- coding: iso-8859-1 -*-

# --- seta43 ---
# http://seta43.duckdns.org
# Prueba de comunicación Arduino a Phyton

import time
import serial
import curses
import os
import sys

#--------RUTINAS----------
def main(stdscr):
    """checking for keypress"""
    stdscr.nodelay(True)  # do not wait for input when calling getch
    return stdscr.getch()

def print_there(x, y, text):
     sys.stdout.write("\x1b7\x1b[%d;%df%s\x1b8" % (y, x, text))
     sys.stdout.flush()
def color_there(ink,paper,estilo):
    cad_cod="\033[%d;%d;%dm" % (estilo,ink,paper)
    print(cad_cod,end='')
"""
Estilos*	Cod. ANSI
Sin efecto	0
Negrita	1
Débil	2
Cursiva	3
Subrayado	4
Inverso	5
Oculto	6
Tachado	7

Colores	Texto	Fondo
Negro	30	40
Rojo	31	41
Verde	32	42
Amarillo	33	43
Azul	34	44
Morado	35	45
Cian	36	46
Blanco	37	47
"""
#------------------------


#Busqueda de port serial  arduino sensores-------------------
puertos=['/dev/ttyUSB0','/dev/ttyUSB1','/dev/ttyACM0','/dev/ttyACM1','/dev/ttyACM2','/dev/ttyS0' ]
portOK=0;
namePort=""

os.system('clear')		#linux  -Para windows os.system('cls')

print ("ESPERANDO 1Segundos")
color_there(0,35,47)

time.sleep(1)

clave="ARDUPY"

count = 0
while count < len(puertos):	
    try:
        arduinoPort = serial.Serial(puertos[count], 9600, timeout=1)
    except:
        print ("ERROR dispositivo " + puertos[count])
    else:
        print ("OK dispositivo " + puertos[count])
        arduinoPort.flushInput()
        print ("Clear buffer y espera 1S")
        time.sleep(1)
        DataSerial = arduinoPort.readline()
        DataSerial = DataSerial.rstrip(b'\r\n')
        DataSerial=DataSerial.decode("utf-8")
        print ("DATO=" + DataSerial + "<-")
        if DataSerial==clave:
            print ("***PORTOK***")
            portOK=1
            namePort=puertos[count]
            break
    count+=1

#-------------

estadoD2=0
estadoD3=0

def estadoLED():
    msg="ESTADO DE LED  D2="+str(estadoD2)+"   D3="+str(estadoD3)
    print_there(1,11,msg)
    

if portOK==0:
    print ("No se encontro ",clave)
else:
 while True:
    tecla=curses.wrapper(main)
    if tecla==81 or tecla==113:
        break
    if tecla==50:
        if estadoD2==0:
            estadoD2=1
            arduinoPort.write(b'D2on\n')
        else:
            estadoD2=0
            arduinoPort.write(b'D2off\n')
        estadoLED()

    if tecla==51:
        if estadoD3==0:
            estadoD3=1
            arduinoPort.write(b'D3on\n')
        else:
            estadoD3=0
            arduinoPort.write(b'D3off\n')
        estadoLED()
    DataSerial = arduinoPort.readline()
    DataSerial = DataSerial.rstrip(b'\r\n')
    DataSerial = DataSerial.decode("utf-8")
    if DataSerial!= "":
        color_there(0,35,47)
        print(DataSerial)
        if DataSerial== "INICIO":
          os.system('clear')		#linux  -Para windows os.system('cls')
          messageA = time.strftime("%d/%m/%y") +"  "+time.strftime("%H:%M:%S") + ("  q=Salir  2=on/off(D2)  3=on/off(D3)")
          color_there(1,32,42)
          print(messageA)
        else:
            if DataSerial[0:7]=='NUMERO=':
              numero = int(DataSerial[7:])
            else:
                if DataSerial[0:7]=='VALOR0=':
                  valor0 = int(DataSerial[7:])
                else:
                    if DataSerial== "FINAL":
                        color_there(1,33,41)
                        print("----------------")
                        print("NUMERO     =" + '{0:4d}'.format(numero) )
                        print("VALOR0     =" + '{0:4d}'.format(valor0) )
                        print ("----------------")
                        color_there(1,32,42)
                        barra=""
                        for z in range(0,int(valor0/15)):
                            barra=barra+" "
                        print(barra)
                        color_there(0,30,47)
                        estadoLED()
    else:
        time.sleep(0.1)
try:
    arduinoPort.close()
except:
    print ("Puerto no abierto")
print ("Programa finalizado")

